diff -r 268ad8e747c8 -r 79a96eefa515 src/libmpeg2/motion_comp_mmx.c
--- a/src/libmpeg2/motion_comp_mmx.c	Mon Jun 25 13:05:45 2007 +0200
+++ b/src/libmpeg2/motion_comp_mmx.c	Wed Jul 04 03:09:58 2007 +0300
@@ -1,6 +1,6 @@
 /*
  * motion_comp_mmx.c
- * Copyright (C) 2000-2002 Michel Lespinasse <walken@zoy.org>
+ * Copyright (C) 2000-2003 Michel Lespinasse <walken@zoy.org>
  * Copyright (C) 1999-2000 Aaron Holtzman <aholtzma@ess.engr.uvic.ca>
  *
  * This file is part of mpeg2dec, a free MPEG-2 video stream decoder.
@@ -27,8 +27,10 @@
 
 #include <inttypes.h>
 
+#include "mpeg2.h"
+#include "attributes.h"
 #include "mpeg2_internal.h"
-#include "xineutils.h"
+#include "mmx.h"
 
 #define CPU_MMXEXT 0
 #define CPU_3DNOW 1
@@ -36,8 +38,21 @@
 
 /* MMX code - needs a rewrite */
 
+/*
+ * Motion Compensation frequently needs to average values using the
+ * formula (x+y+1)>>1. Both MMXEXT and 3Dnow include one instruction
+ * to compute this, but it's been left out of classic MMX.
+ *
+ * We need to be careful of overflows when doing this computation.
+ * Rather than unpacking data to 16-bits, which reduces parallelism,
+ * we use the following formulas:
+ *
+ * (x+y)>>1 == (x&y)+((x^y)>>1)
+ * (x+y+1)>>1 == (x|y)-((x^y)>>1)
+ */
+
 /* some rounding constants */
-static mmx_t round1 = {0x0001000100010001LL};
+static mmx_t mask1 = {0xfefefefefefefefeLL};
 static mmx_t round4 = {0x0002000200020002LL};
 
 /*
@@ -54,202 +69,176 @@ static inline void mmx_zero_reg ()
     pxor_r2r (mm0, mm0);
 }
 
-static inline void mmx_average_2_U8 (uint8_t * dest,
-				     uint8_t * src1, uint8_t * src2)
+static inline void mmx_average_2_U8 (uint8_t * dest, const uint8_t * src1,
+				     const uint8_t * src2)
 {
     /* *dest = (*src1 + *src2 + 1)/ 2; */
 
-    movq_m2r (*src1, mm1);	// load 8 src1 bytes
-    movq_r2r (mm1, mm2);	// copy 8 src1 bytes
-
-    movq_m2r (*src2, mm3);	// load 8 src2 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src2 bytes
-
-    punpcklbw_r2r (mm0, mm1);	// unpack low src1 bytes
-    punpckhbw_r2r (mm0, mm2);	// unpack high src1 bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src2 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src2 bytes
-
-    paddw_r2r (mm3, mm1);	// add lows to mm1
-    paddw_m2r (round1, mm1);
-    psraw_i2r (1, mm1);		// /2
-
-    paddw_r2r (mm4, mm2);	// add highs to mm2
-    paddw_m2r (round1, mm2);
-    psraw_i2r (1, mm2);		// /2
-
-    packuswb_r2r (mm2, mm1);	// pack (w/ saturation)
-    movq_r2m (mm1, *dest);	// store result in dest
+    movq_m2r (*src1, mm1);	/* load 8 src1 bytes */
+    movq_r2r (mm1, mm2);	/* copy 8 src1 bytes */
+
+    movq_m2r (*src2, mm3);	/* load 8 src2 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src2 bytes */
+
+    pxor_r2r (mm1, mm3);	/* xor src1 and src2 */
+    pand_m2r (mask1, mm3);	/* mask lower bits */
+    psrlq_i2r (1, mm3);		/* /2 */
+    por_r2r (mm2, mm4);		/* or src1 and src2 */
+    psubb_r2r (mm3, mm4);	/* subtract subresults */
+    movq_r2m (mm4, *dest);	/* store result in dest */
 }
 
 static inline void mmx_interp_average_2_U8 (uint8_t * dest,
-					    uint8_t * src1, uint8_t * src2)
+					    const uint8_t * src1,
+					    const uint8_t * src2)
 {
     /* *dest = (*dest + (*src1 + *src2 + 1)/ 2 + 1)/ 2; */
 
-    movq_m2r (*dest, mm1);	// load 8 dest bytes
-    movq_r2r (mm1, mm2);	// copy 8 dest bytes
-
-    movq_m2r (*src1, mm3);	// load 8 src1 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src1 bytes
-
-    movq_m2r (*src2, mm5);	// load 8 src2 bytes
-    movq_r2r (mm5, mm6);	// copy 8 src2 bytes
-
-    punpcklbw_r2r (mm0, mm1);	// unpack low dest bytes
-    punpckhbw_r2r (mm0, mm2);	// unpack high dest bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src1 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src1 bytes
-
-    punpcklbw_r2r (mm0, mm5);	// unpack low src2 bytes
-    punpckhbw_r2r (mm0, mm6);	// unpack high src2 bytes
-
-    paddw_r2r (mm5, mm3);	// add lows
-    paddw_m2r (round1, mm3);
-    psraw_i2r (1, mm3);		// /2
-
-    paddw_r2r (mm6, mm4);	// add highs
-    paddw_m2r (round1, mm4);
-    psraw_i2r (1, mm4);		// /2
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_m2r (round1, mm1);
-    psraw_i2r (1, mm1);		// /2
-
-    paddw_r2r (mm4, mm2);	// add highs
-    paddw_m2r (round1, mm2);
-    psraw_i2r (1, mm2);		// /2
-
-    packuswb_r2r (mm2, mm1);	// pack (w/ saturation)
-    movq_r2m (mm1, *dest);	// store result in dest
-}
-
-static inline void mmx_average_4_U8 (uint8_t * dest,
-				     uint8_t * src1, uint8_t * src2,
-				     uint8_t * src3, uint8_t * src4)
+    movq_m2r (*dest, mm1);	/* load 8 dest bytes */
+    movq_r2r (mm1, mm2);	/* copy 8 dest bytes */
+
+    movq_m2r (*src1, mm3);	/* load 8 src1 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src1 bytes */
+
+    movq_m2r (*src2, mm5);	/* load 8 src2 bytes */
+    movq_r2r (mm5, mm6);	/* copy 8 src2 bytes */
+
+    pxor_r2r (mm3, mm5);	/* xor src1 and src2 */
+    pand_m2r (mask1, mm5);	/* mask lower bits */
+    psrlq_i2r (1, mm5);		/* /2 */
+    por_r2r (mm4, mm6);		/* or src1 and src2 */
+    psubb_r2r (mm5, mm6);	/* subtract subresults */
+    movq_r2r (mm6, mm5);	/* copy subresult */
+
+    pxor_r2r (mm1, mm5);	/* xor srcavg and dest */
+    pand_m2r (mask1, mm5);	/* mask lower bits */
+    psrlq_i2r (1, mm5);		/* /2 */
+    por_r2r (mm2, mm6);		/* or srcavg and dest */
+    psubb_r2r (mm5, mm6);	/* subtract subresults */
+    movq_r2m (mm6, *dest);	/* store result in dest */
+}
+
+static inline void mmx_average_4_U8 (uint8_t * dest, const uint8_t * src1,
+				     const uint8_t * src2,
+				     const uint8_t * src3,
+				     const uint8_t * src4)
 {
     /* *dest = (*src1 + *src2 + *src3 + *src4 + 2)/ 4; */
 
-    movq_m2r (*src1, mm1);	// load 8 src1 bytes
-    movq_r2r (mm1, mm2);	// copy 8 src1 bytes
-
-    punpcklbw_r2r (mm0, mm1);	// unpack low src1 bytes
-    punpckhbw_r2r (mm0, mm2);	// unpack high src1 bytes
-
-    movq_m2r (*src2, mm3);	// load 8 src2 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src2 bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src2 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src2 bytes
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_r2r (mm4, mm2);	// add highs
+    movq_m2r (*src1, mm1);	/* load 8 src1 bytes */
+    movq_r2r (mm1, mm2);	/* copy 8 src1 bytes */
+
+    punpcklbw_r2r (mm0, mm1);	/* unpack low src1 bytes */
+    punpckhbw_r2r (mm0, mm2);	/* unpack high src1 bytes */
+
+    movq_m2r (*src2, mm3);	/* load 8 src2 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src2 bytes */
+
+    punpcklbw_r2r (mm0, mm3);	/* unpack low src2 bytes */
+    punpckhbw_r2r (mm0, mm4);	/* unpack high src2 bytes */
+
+    paddw_r2r (mm3, mm1);	/* add lows */
+    paddw_r2r (mm4, mm2);	/* add highs */
 
     /* now have partials in mm1 and mm2 */
 
-    movq_m2r (*src3, mm3);	// load 8 src3 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src3 bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src3 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src3 bytes
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_r2r (mm4, mm2);	// add highs
-
-    movq_m2r (*src4, mm5);	// load 8 src4 bytes
-    movq_r2r (mm5, mm6);	// copy 8 src4 bytes
-
-    punpcklbw_r2r (mm0, mm5);	// unpack low src4 bytes
-    punpckhbw_r2r (mm0, mm6);	// unpack high src4 bytes
-
-    paddw_r2r (mm5, mm1);	// add lows
-    paddw_r2r (mm6, mm2);	// add highs
+    movq_m2r (*src3, mm3);	/* load 8 src3 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src3 bytes */
+
+    punpcklbw_r2r (mm0, mm3);	/* unpack low src3 bytes */
+    punpckhbw_r2r (mm0, mm4);	/* unpack high src3 bytes */
+
+    paddw_r2r (mm3, mm1);	/* add lows */
+    paddw_r2r (mm4, mm2);	/* add highs */
+
+    movq_m2r (*src4, mm5);	/* load 8 src4 bytes */
+    movq_r2r (mm5, mm6);	/* copy 8 src4 bytes */
+
+    punpcklbw_r2r (mm0, mm5);	/* unpack low src4 bytes */
+    punpckhbw_r2r (mm0, mm6);	/* unpack high src4 bytes */
+
+    paddw_r2r (mm5, mm1);	/* add lows */
+    paddw_r2r (mm6, mm2);	/* add highs */
 
     /* now have subtotal in mm1 and mm2 */
 
     paddw_m2r (round4, mm1);
-    psraw_i2r (2, mm1);		// /4
+    psraw_i2r (2, mm1);		/* /4 */
     paddw_m2r (round4, mm2);
-    psraw_i2r (2, mm2);		// /4
-
-    packuswb_r2r (mm2, mm1);	// pack (w/ saturation)
-    movq_r2m (mm1, *dest);	// store result in dest
+    psraw_i2r (2, mm2);		/* /4 */
+
+    packuswb_r2r (mm2, mm1);	/* pack (w/ saturation) */
+    movq_r2m (mm1, *dest);	/* store result in dest */
 }
 
 static inline void mmx_interp_average_4_U8 (uint8_t * dest,
-					    uint8_t * src1, uint8_t * src2,
-					    uint8_t * src3, uint8_t * src4)
+					    const uint8_t * src1,
+					    const uint8_t * src2,
+					    const uint8_t * src3,
+					    const uint8_t * src4)
 {
     /* *dest = (*dest + (*src1 + *src2 + *src3 + *src4 + 2)/ 4 + 1)/ 2; */
 
-    movq_m2r (*src1, mm1);	// load 8 src1 bytes
-    movq_r2r (mm1, mm2);	// copy 8 src1 bytes
-
-    punpcklbw_r2r (mm0, mm1);	// unpack low src1 bytes
-    punpckhbw_r2r (mm0, mm2);	// unpack high src1 bytes
-
-    movq_m2r (*src2, mm3);	// load 8 src2 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src2 bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src2 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src2 bytes
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_r2r (mm4, mm2);	// add highs
+    movq_m2r (*src1, mm1);	/* load 8 src1 bytes */
+    movq_r2r (mm1, mm2);	/* copy 8 src1 bytes */
+
+    punpcklbw_r2r (mm0, mm1);	/* unpack low src1 bytes */
+    punpckhbw_r2r (mm0, mm2);	/* unpack high src1 bytes */
+
+    movq_m2r (*src2, mm3);	/* load 8 src2 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src2 bytes */
+
+    punpcklbw_r2r (mm0, mm3);	/* unpack low src2 bytes */
+    punpckhbw_r2r (mm0, mm4);	/* unpack high src2 bytes */
+
+    paddw_r2r (mm3, mm1);	/* add lows */
+    paddw_r2r (mm4, mm2);	/* add highs */
 
     /* now have partials in mm1 and mm2 */
 
-    movq_m2r (*src3, mm3);	// load 8 src3 bytes
-    movq_r2r (mm3, mm4);	// copy 8 src3 bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low src3 bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high src3 bytes
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_r2r (mm4, mm2);	// add highs
-
-    movq_m2r (*src4, mm5);	// load 8 src4 bytes
-    movq_r2r (mm5, mm6);	// copy 8 src4 bytes
-
-    punpcklbw_r2r (mm0, mm5);	// unpack low src4 bytes
-    punpckhbw_r2r (mm0, mm6);	// unpack high src4 bytes
-
-    paddw_r2r (mm5, mm1);	// add lows
-    paddw_r2r (mm6, mm2);	// add highs
+    movq_m2r (*src3, mm3);	/* load 8 src3 bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 src3 bytes */
+
+    punpcklbw_r2r (mm0, mm3);	/* unpack low src3 bytes */
+    punpckhbw_r2r (mm0, mm4);	/* unpack high src3 bytes */
+
+    paddw_r2r (mm3, mm1);	/* add lows */
+    paddw_r2r (mm4, mm2);	/* add highs */
+
+    movq_m2r (*src4, mm5);	/* load 8 src4 bytes */
+    movq_r2r (mm5, mm6);	/* copy 8 src4 bytes */
+
+    punpcklbw_r2r (mm0, mm5);	/* unpack low src4 bytes */
+    punpckhbw_r2r (mm0, mm6);	/* unpack high src4 bytes */
+
+    paddw_r2r (mm5, mm1);	/* add lows */
+    paddw_r2r (mm6, mm2);	/* add highs */
 
     paddw_m2r (round4, mm1);
-    psraw_i2r (2, mm1);		// /4
+    psraw_i2r (2, mm1);		/* /4 */
     paddw_m2r (round4, mm2);
-    psraw_i2r (2, mm2);		// /4
+    psraw_i2r (2, mm2);		/* /4 */
 
     /* now have subtotal/4 in mm1 and mm2 */
 
-    movq_m2r (*dest, mm3);	// load 8 dest bytes
-    movq_r2r (mm3, mm4);	// copy 8 dest bytes
-
-    punpcklbw_r2r (mm0, mm3);	// unpack low dest bytes
-    punpckhbw_r2r (mm0, mm4);	// unpack high dest bytes
-
-    paddw_r2r (mm3, mm1);	// add lows
-    paddw_r2r (mm4, mm2);	// add highs
-
-    paddw_m2r (round1, mm1);
-    psraw_i2r (1, mm1);		// /2
-    paddw_m2r (round1, mm2);
-    psraw_i2r (1, mm2);		// /2
-
-    /* now have end value in mm1 and mm2 */
-
-    packuswb_r2r (mm2, mm1);	// pack (w/ saturation)
-    movq_r2m (mm1,*dest);	// store result in dest
+    movq_m2r (*dest, mm3);	/* load 8 dest bytes */
+    movq_r2r (mm3, mm4);	/* copy 8 dest bytes */
+
+    packuswb_r2r (mm2, mm1);	/* pack (w/ saturation) */
+    movq_r2r (mm1,mm2);		/* copy subresult */
+
+    pxor_r2r (mm1, mm3);	/* xor srcavg and dest */
+    pand_m2r (mask1, mm3);	/* mask lower bits */
+    psrlq_i2r (1, mm3);		/* /2 */
+    por_r2r (mm2, mm4);		/* or srcavg and dest */
+    psubb_r2r (mm3, mm4);	/* subtract subresults */
+    movq_r2m (mm4, *dest);	/* store result in dest */
 }
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_avg_mmx (int width, int height,
-			       uint8_t * dest, uint8_t * ref, int stride)
+static inline void MC_avg_mmx (const int width, int height, uint8_t * dest,
+			       const uint8_t * ref, const int stride)
 {
     mmx_zero_reg ();
 
@@ -264,13 +253,13 @@ static inline void MC_avg_mmx (int width
     } while (--height);
 }
 
-static void MC_avg_o_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_avg_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_avg_o_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_avg_mmx (8, height, dest, ref, stride);
@@ -278,19 +267,19 @@ static void MC_avg_o_8_mmx (uint8_t * de
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_put_mmx (int width, int height,
-			       uint8_t * dest, uint8_t * ref, int stride)
+static inline void MC_put_mmx (const int width, int height, uint8_t * dest,
+			       const uint8_t * ref, const int stride)
 {
     mmx_zero_reg ();
 
     do {
-	movq_m2r (* ref, mm1);	// load 8 ref bytes
-	movq_r2m (mm1,* dest);	// store 8 bytes at curr
+	movq_m2r (* ref, mm1);	/* load 8 ref bytes */
+	movq_r2m (mm1,* dest);	/* store 8 bytes at curr */
 
 	if (width == 16)
 	    {
-		movq_m2r (* (ref+8), mm1);	// load 8 ref bytes
-		movq_r2m (mm1,* (dest+8));	// store 8 bytes at curr
+		movq_m2r (* (ref+8), mm1);	/* load 8 ref bytes */
+		movq_r2m (mm1,* (dest+8));	/* store 8 bytes at curr */
 	    }
 
 	dest += stride;
@@ -298,13 +287,13 @@ static inline void MC_put_mmx (int width
     } while (--height);
 }
 
-static void MC_put_o_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_put_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_put_o_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_put_mmx (8, height, dest, ref, stride);
@@ -313,8 +302,8 @@ static void MC_put_o_8_mmx (uint8_t * de
 /*-----------------------------------------------------------------------*/
 
 /* Half pixel interpolation in the x direction */
-static inline void MC_avg_x_mmx (int width, int height,
-				 uint8_t * dest, uint8_t * ref, int stride)
+static inline void MC_avg_x_mmx (const int width, int height, uint8_t * dest,
+				 const uint8_t * ref, const int stride)
 {
     mmx_zero_reg ();
 
@@ -329,13 +318,13 @@ static inline void MC_avg_x_mmx (int wid
     } while (--height);
 }
 
-static void MC_avg_x_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_avg_x_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_avg_x_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_avg_x_mmx (8, height, dest, ref, stride);
@@ -343,8 +332,8 @@ static void MC_avg_x_8_mmx (uint8_t * de
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_put_x_mmx (int width, int height,
-				 uint8_t * dest, uint8_t * ref, int stride)
+static inline void MC_put_x_mmx (const int width, int height, uint8_t * dest,
+				 const uint8_t * ref, const int stride)
 {
     mmx_zero_reg ();
 
@@ -359,13 +348,13 @@ static inline void MC_put_x_mmx (int wid
     } while (--height);
 }
 
-static void MC_put_x_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_put_x_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_put_x_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_put_x_mmx (8, height, dest, ref, stride);
@@ -373,10 +362,10 @@ static void MC_put_x_8_mmx (uint8_t * de
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_avg_xy_mmx (int width, int height,
-				  uint8_t * dest, uint8_t * ref, int stride)
-{
-    uint8_t * ref_next = ref+stride;
+static inline void MC_avg_xy_mmx (const int width, int height, uint8_t * dest,
+				  const uint8_t * ref, const int stride)
+{
+    const uint8_t * ref_next = ref + stride;
 
     mmx_zero_reg ();
 
@@ -393,13 +382,13 @@ static inline void MC_avg_xy_mmx (int wi
     } while (--height);
 }
 
-static void MC_avg_xy_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_16_mmx (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_avg_xy_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_avg_xy_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_8_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_avg_xy_mmx (8, height, dest, ref, stride);
@@ -407,10 +396,10 @@ static void MC_avg_xy_8_mmx (uint8_t * d
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_put_xy_mmx (int width, int height,
-				  uint8_t * dest, uint8_t * ref, int stride)
-{
-    uint8_t * ref_next = ref+stride;
+static inline void MC_put_xy_mmx (const int width, int height, uint8_t * dest,
+				  const uint8_t * ref, const int stride)
+{
+    const uint8_t * ref_next = ref + stride;
 
     mmx_zero_reg ();
 
@@ -426,13 +415,13 @@ static inline void MC_put_xy_mmx (int wi
     } while (--height);
 }
 
-static void MC_put_xy_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_16_mmx (uint8_t * dest, const uint8_t * ref,
 			      int stride, int height)
 {
     MC_put_xy_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_put_xy_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_8_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_put_xy_mmx (8, height, dest, ref, stride);
@@ -440,10 +429,10 @@ static void MC_put_xy_8_mmx (uint8_t * d
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_avg_y_mmx (int width, int height,
-				 uint8_t * dest, uint8_t * ref, int stride)
-{
-    uint8_t * ref_next = ref+stride;
+static inline void MC_avg_y_mmx (const int width, int height, uint8_t * dest,
+				 const uint8_t * ref, const int stride)
+{
+    const uint8_t * ref_next = ref + stride;
 
     mmx_zero_reg ();
 
@@ -459,13 +448,13 @@ static inline void MC_avg_y_mmx (int wid
     } while (--height);
 }
 
-static void MC_avg_y_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_avg_y_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_avg_y_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_avg_y_mmx (8, height, dest, ref, stride);
@@ -473,10 +462,10 @@ static void MC_avg_y_8_mmx (uint8_t * de
 
 /*-----------------------------------------------------------------------*/
 
-static inline void MC_put_y_mmx (int width, int height,
-				 uint8_t * dest, uint8_t * ref, int stride)
-{
-    uint8_t * ref_next = ref+stride;
+static inline void MC_put_y_mmx (const int width, int height, uint8_t * dest,
+				 const uint8_t * ref, const int stride)
+{
+    const uint8_t * ref_next = ref + stride;
 
     mmx_zero_reg ();
 
@@ -492,13 +481,13 @@ static inline void MC_put_y_mmx (int wid
     } while (--height);
 }
 
-static void MC_put_y_16_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_16_mmx (uint8_t * dest, const uint8_t * ref,
 			     int stride, int height)
 {
     MC_put_y_mmx (16, height, dest, ref, stride);
 }
 
-static void MC_put_y_8_mmx (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_8_mmx (uint8_t * dest, const uint8_t * ref,
 			    int stride, int height)
 {
     MC_put_y_mmx (8, height, dest, ref, stride);
@@ -535,19 +524,19 @@ do {					\
 /* CPU_MMXEXT code */
 
 
-static inline void MC_put1_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride)
-{
-    do {
-	movq_m2r (*ref, mm0);
-	movq_r2m (mm0, *dest);
-	ref += stride;
-	dest += stride;
-    } while (--height);
-}
-
-static inline void MC_put1_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride)
+static inline void MC_put1_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride)
+{
+    do {
+	movq_m2r (*ref, mm0);
+	movq_r2m (mm0, *dest);
+	ref += stride;
+	dest += stride;
+    } while (--height);
+}
+
+static inline void MC_put1_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -559,8 +548,8 @@ static inline void MC_put1_16 (int heigh
     } while (--height);
 }
 
-static inline void MC_avg1_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride, int cpu)
+static inline void MC_avg1_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride, const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -571,8 +560,8 @@ static inline void MC_avg1_8 (int height
     } while (--height);
 }
 
-static inline void MC_avg1_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride, int cpu)
+static inline void MC_avg1_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride, const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -586,8 +575,9 @@ static inline void MC_avg1_16 (int heigh
     } while (--height);
 }
 
-static inline void MC_put2_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride, int offset, int cpu)
+static inline void MC_put2_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride, const int offset,
+			      const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -598,8 +588,9 @@ static inline void MC_put2_8 (int height
     } while (--height);
 }
 
-static inline void MC_put2_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride, int offset, int cpu)
+static inline void MC_put2_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride, const int offset,
+			       const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -613,8 +604,9 @@ static inline void MC_put2_16 (int heigh
     } while (--height);
 }
 
-static inline void MC_avg2_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride, int offset, int cpu)
+static inline void MC_avg2_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride, const int offset,
+			      const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -626,8 +618,9 @@ static inline void MC_avg2_8 (int height
     } while (--height);
 }
 
-static inline void MC_avg2_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride, int offset, int cpu)
+static inline void MC_avg2_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride, const int offset,
+			       const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -645,8 +638,8 @@ static inline void MC_avg2_16 (int heigh
 
 static mmx_t mask_one = {0x0101010101010101LL};
 
-static inline void MC_put4_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride, int cpu)
+static inline void MC_put4_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride, const int cpu)
 {
     movq_m2r (*ref, mm0);
     movq_m2r (*(ref+1), mm1);
@@ -679,13 +672,13 @@ static inline void MC_put4_8 (int height
 	movq_r2m (mm0, *dest);
 	dest += stride;
 
-	movq_r2r (mm6, mm7);	// unroll !
-	movq_r2r (mm2, mm0);	// unroll !
-    } while (--height);
-}
-
-static inline void MC_put4_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride, int cpu)
+	movq_r2r (mm6, mm7);	/* unroll ! */
+	movq_r2r (mm2, mm0);	/* unroll ! */
+    } while (--height);
+}
+
+static inline void MC_put4_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride, const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -730,8 +723,8 @@ static inline void MC_put4_16 (int heigh
     } while (--height);
 }
 
-static inline void MC_avg4_8 (int height, uint8_t * dest, uint8_t * ref,
-			      int stride, int cpu)
+static inline void MC_avg4_8 (int height, uint8_t * dest, const uint8_t * ref,
+			      const int stride, const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -759,8 +752,8 @@ static inline void MC_avg4_8 (int height
     } while (--height);
 }
 
-static inline void MC_avg4_16 (int height, uint8_t * dest, uint8_t * ref,
-			       int stride, int cpu)
+static inline void MC_avg4_16 (int height, uint8_t * dest, const uint8_t * ref,
+			       const int stride, const int cpu)
 {
     do {
 	movq_m2r (*ref, mm0);
@@ -809,97 +802,97 @@ static inline void MC_avg4_16 (int heigh
     } while (--height);
 }
 
-static void MC_avg_o_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_avg1_16 (height, dest, ref, stride, CPU_MMXEXT);
 }
 
-static void MC_avg_o_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_o_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg1_8 (height, dest, ref, stride, CPU_MMXEXT);
 }
 
-static void MC_put_o_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_put1_16 (height, dest, ref, stride);
 }
 
-static void MC_put_o_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_o_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put1_8 (height, dest, ref, stride);
 }
 
-static void MC_avg_x_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_avg2_16 (height, dest, ref, stride, 1, CPU_MMXEXT);
 }
 
-static void MC_avg_x_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_x_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg2_8 (height, dest, ref, stride, 1, CPU_MMXEXT);
 }
 
-static void MC_put_x_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_put2_16 (height, dest, ref, stride, 1, CPU_MMXEXT);
 }
 
-static void MC_put_x_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_x_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put2_8 (height, dest, ref, stride, 1, CPU_MMXEXT);
 }
 
-static void MC_avg_y_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_avg2_16 (height, dest, ref, stride, stride, CPU_MMXEXT);
 }
 
-static void MC_avg_y_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_y_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_avg2_8 (height, dest, ref, stride, stride, CPU_MMXEXT);
 }
 
-static void MC_put_y_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_put2_16 (height, dest, ref, stride, stride, CPU_MMXEXT);
 }
 
-static void MC_put_y_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_y_8_mmxext (uint8_t * dest, const uint8_t * ref,
 			       int stride, int height)
 {
     MC_put2_8 (height, dest, ref, stride, stride, CPU_MMXEXT);
 }
 
-static void MC_avg_xy_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				 int stride, int height)
 {
     MC_avg4_16 (height, dest, ref, stride, CPU_MMXEXT);
 }
 
-static void MC_avg_xy_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_avg_xy_8_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_avg4_8 (height, dest, ref, stride, CPU_MMXEXT);
 }
 
-static void MC_put_xy_16_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_16_mmxext (uint8_t * dest, const uint8_t * ref,
 				 int stride, int height)
 {
     MC_put4_16 (height, dest, ref, stride, CPU_MMXEXT);
 }
 
-static void MC_put_xy_8_mmxext (uint8_t * dest, uint8_t * ref,
+static void MC_put_xy_8_mmxext (uint8_t * dest, const uint8_t * ref,
 				int stride, int height)
 {
     MC_put4_8 (height, dest, ref, stride, CPU_MMXEXT);
